HDU 1114 Piggy-Bank 【完全背包(时间优化)】


Problem Description
Before ACM can do anything, a budget must be prepared and the necessary financial support obtained. The main income for this action comes from Irreversibly Bound Money (IBM). The idea behind is simple. Whenever some ACM member has any small money, he takes all the coins and throws them into a piggy-bank. You know that this process is irreversible, the coins cannot be removed without breaking the pig. After a sufficiently long time, there should be enough cash in the piggy-bank to pay everything that needs to be paid. 

But there is a big problem with piggy-banks. It is not possible to determine how much money is inside. So we might break the pig into pieces only to find out that there is not enough money. Clearly, we want to avoid this unpleasant situation. The only possibility is to weigh the piggy-bank and try to guess how many coins are inside. Assume that we are able to determine the weight of the pig exactly and that we know the weights of all coins of a given currency. Then there is some minimum amount of money in the piggy-bank that we can guarantee. Your task is to find out this worst case and determine the minimum amount of cash inside the piggy-bank. We need your help. No more prematurely broken pigs!
 

Input
The input consists of T test cases. The number of them (T) is given on the first line of the input file. Each test case begins with a line containing two integers E and F. They indicate the weight of an empty pig and of the pig filled with coins. Both weights are given in grams. No pig will weigh more than 10 kg, that means 1 <= E <= F <= 10000. On the second line of each test case, there is an integer number N (1 <= N <= 500) that gives the number of various coins used in the given currency. Following this are exactly N lines, each specifying one coin type. These lines contain two integers each, Pand W (1 <= P <= 50000, 1 <= W <=10000). P is the value of the coin in monetary units, W is it's weight in grams.
 

Output
Print exactly one line of output for each test case. The line must contain the sentence "The minimum amount of money in the piggy-bank is X." where X is the minimum amount of money that can be achieved using coins with the given total weight. If the weight cannot be reached exactly, print a line "This is impossible.".
 

Sample Input
3 10 110 2 1 1 30 50 10 110 2 1 1 50 30 1 6 2 10 3 20 4
 

Sample Output
The minimum amount of money in the piggy-bank is 60. The minimum amount of money in the piggy-bank is 100. This is impossible.

思路:一般的背包是求最大值的,如果求相反的情况的话,只要把dp的初始值对调一下就行了,最大值的背包dp的初始化是 0,这里要注意的是dp【0】= 0并不是初始化,而是一个确定的值,求最小,初始化要补除 0 外 全部初始化为一个很大的值 INF

不知道用没有时间优化的完全背包会不会超时,下面的代码是用了时间优化的:


#include<cstdio>
#include<cstring>
#include<cmath>
#include<algorithm>
#include<iostream>

using namespace std;

#define Maxn 10010
#define INF 999999999

int dp[Maxn],price[Maxn],w[Maxn];

int main(void)
{
   // freopen ("in.txt","r",stdin);
   // freopen ("out.txt","w",stdout);
    int t,E,F,kind;
    while (scanf("%d",&t)!=EOF) {
        while (t--) {
            scanf("%d%d%d",&E,&F,&kind);
            for (int i = 1; i <= kind; ++i) {
                scanf("%d%d",&price[i],&w[i]);
            }
            int max_p = F-E;
            dp[0] = 0; // 这里的初始值设置为INF,表示还没有填入数据,但是要单独把dp[0]隔开,
                        //如果是求最大的值的话,就可以全部初始化为 0 ,如果是这里,dp[0]的值是确定的
                        //就是等于 0,因为当背包的重量为0的时候,等于啥都没放
            for (int i = 1; i <= max_p; ++i) dp[i] = INF;  
            // 如果dp初始化为INF,如果用时间优化的方程求的话,是填入不了值得,
            //观察一下公式就知道,最小值一定是INF,所以第一次的时候,要把数据填入;
            //填入的数据就是 1 到 k 个第一种price填到对应的dp中
            for (int k = 1; k*w[1] <= max_p; ++k) dp[k*w[1]] = k*price[1];

            for (int i = 2; i <= kind; ++i) {
                for (int j = 1; j <= max_p; ++j) {
                    if(j-w[i] < 0 ) continue;
                    else dp[j] = min(dp[j],dp[j-w[i]] + price[i]); // 这里用到了完全背包的时间优化
                }
            }
            if(dp[max_p] < INF) printf("The minimum amount of money in the piggy-bank is %d.\n",dp[max_p]);
            else printf("This is impossible.\n");
        }
    }
    return 0;
}

这里时间优化的方法提示一下:如果是从 0 开始更新dp的话,那么 dp[ j ] 这个地方的k种取法有  dp[ j - 1*w[i] ] ,dp[ j - 2*w[i] ], dp[ j - 3*w[i] ],,,,dp[ j - k*w[i] ];那么如果是 dp[ j + w[i] ] ,k种取法有 dp[ j + w[i] - 1*w[i] ] ,dp [ j + w[i] -2*w[i] ], dp[ j + w[i] - 3*w[i] ] ,,,dp[ j +w[i] - k*w[i] ];很明显的,dp[ j ] 比较过的数据, dp[ j + w[i] ] 有很多是重复了,我们把上面的规律整理一下,就会发现,dp[ j + w[i] ] 的 k种情况的比较数据的结果,就是 dp[ j ] + v[ i ]; 这里的 v 是价值;不是非常的清晰,最好是根据提示自己独立思考;





猜你喜欢

转载自blog.csdn.net/godleaf/article/details/81038489
今日推荐